/*
 * Copyright 1997, Silicon Graphics, Inc.
 * ALL RIGHTS RESERVED
 *
 * UNPUBLISHED -- Rights reserved under the copyright laws of the United
 * States.   Use of a copyright notice is precautionary only and does not
 * imply publication or disclosure.
 *
 * U.S. GOVERNMENT RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in FAR 52.227.19(c)(2) or subparagraph (c)(1)(ii) of the Rights
 * in Technical Data and Computer Software clause at DFARS 252.227-7013 and/or
 * in similar or successor clauses in the FAR, or the DOD or NASA FAR
 * Supplement.  Contractor/manufacturer is Silicon Graphics, Inc.,
 * 2011 N. Shoreline Blvd. Mountain View, CA 94039-7311.
 *
 * THE CONTENT OF THIS WORK CONTAINS CONFIDENTIAL AND PROPRIETARY
 * INFORMATION OF SILICON GRAPHICS, INC. ANY DUPLICATION, MODIFICATION,
 * DISTRIBUTION, OR DISCLOSURE IN ANY FORM, IN WHOLE, OR IN PART, IS STRICTLY
 * PROHIBITED WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SILICON
 * GRAPHICS, INC.
 *
 * $Id: trace_hash.h,v 1.9 1997/07/16 20:26:22 kenmcd Exp $
 */

#ifndef _TRACE_HASH_H
#define _TRACE_HASH_H

#ifdef __cplusplus      
extern "C" {
#endif

typedef int  (*__pmHashCmpFunc)(void *, void *);
typedef int  (*__pmHashKeyCmpFunc)(void *, const char *);
typedef void (*__pmHashDelFunc)(void *);

struct __pmHashEl {
    void		*ent;
    struct __pmHashEl	*next;
};
typedef struct __pmHashEl __pmHashEnt;

typedef struct {
    size_t		tsize;
    size_t		esize;
    unsigned int	entries;
    __pmHashCmpFunc	cmp;
    __pmHashDelFunc	del;
    __pmHashEnt		**rows;
    /*void		**pool;*/
} __pmHashTable;

extern int __pmhashinit(__pmHashTable *, size_t, size_t, __pmHashCmpFunc, __pmHashDelFunc);

extern void __pmhashtrunc(__pmHashTable *);

extern int __pmhashinsert(__pmHashTable *, const char *, void *);

extern void *__pmhashlookup(__pmHashTable *, const char *, void *);

typedef void (*__pmHashIterFunc)(__pmHashTable *, void *);
extern void __pmhashtraverse(__pmHashTable *, __pmHashIterFunc);

#ifndef PM_HASH_TUNE
#define PM_HASH_SHFT	5
#define PM_HASH_SIZE	31
#endif

#ifdef __cplusplus      
}
#endif

#endif /* _TRACE_HASH_H */
