	program fapp1

C Copyright 1997, Silicon Graphics, Inc.
C ALL RIGHTS RESERVED
C 
C UNPUBLISHED -- Rights reserved under the copyright laws of the United
C States.   Use of a copyright notice is precautionary only and does not
C imply publication or disclosure.
C 
C U.S. GOVERNMENT RESTRICTED RIGHTS LEGEND:
C Use, duplication or disclosure by the Government is subject to restrictions
C as set forth in FAR 52.227.19(c)(2) or subparagraph (c)(1)(ii) of the Rights
C in Technical Data and Computer Software clause at DFARS 252.227-7013 and/or
C in similar or successor clauses in the FAR, or the DOD or NASA FAR
C Supplement.  Contractor/manufacturer is Silicon Graphics, Inc.,
C 2011 N. Shoreline Blvd. Mountain View, CA 94039-7311.
C 
C THE CONTENT OF THIS WORK CONTAINS CONFIDENTIAL AND PROPRIETARY
C INFORMATION OF SILICON GRAPHICS, INC. ANY DUPLICATION, MODIFICATION,
C DISTRIBUTION, OR DISCLOSURE IN ANY FORM, IN WHOLE, OR IN PART, IS STRICTLY
C PROHIBITED WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SILICON
C GRAPHICS, INC.

C fapp1.f
C
C Simple program to demonstrate use of the PCP trace performance metrics
C domain agent (PMDA(3)).  This agent needs to be installed before metrics
C can be made available via the performance metrics namespace (PMNS(4)),
C and the Performance Metrics Collector Daemon (PMCD(1)).
C
C Once this program is running, the trace PMDA metrics & instances can be
C viewed through PCP monitor tools such as pmchart(1), pmgadgets(1), and
C pmview(1).  To view the help text associated with each of these metrics,
C use:
C    $ pminfo -tT trace
C
C The pmtracestate constants are defined in /usr/include/pcp/trace.h
C
	external pmtracebegin, pmtraceend, pmtracepoint, pmtraceerrstr, pmtracestate
	integer pmtracebegin, pmtraceend, pmtracepoint
	integer sts
	integer debug
	character*5 prog
	character*40 emesg
	real*8 value
	integer dbg_noagent, dbg_api, dbg_comms, dbg_pdu
	parameter (dbg_noagent = 1, dbg_api = 2, dbg_comms = 4, dbg_pdu = 8)

	prog='fapp1'

C	Addition below is the equivalent to the C 'logical or' operator as
C	trace API constants are all disjoint and the high bit is never set.
	debug = (dbg_api + dbg_comms + dbg_pdu)
	call pmtracestate(debug)

	sts = pmtracebegin('simple')
	if (sts .lt. 0) then
	    call pmtraceerrstr(sts, emesg)
	    print *,prog,': pmtracebegin error: ',emesg
	    stop 1
	endif
	call sleep(2)
	sts = pmtraceend('simple')
	if (sts .lt. 0) then
	    call pmtraceerrstr(sts, emesg)
	    print *,prog,': pmtraceend error: ',emesg
	    stop 1
	endif

	sts = pmtracebegin('ascanbe')
	if (sts .lt. 0) then
	    call pmtraceerrstr(sts, emesg)
	    print *,prog,': pmtracebegin error: ',emesg
	    stop 1
	endif
	call sleep(1)
	sts = pmtraceend('ascanbe')
	if (sts .lt. 0) then
	    call pmtraceerrstr(sts, emesg)
	    print *,prog,': pmtraceend error: ',emesg
	    stop 1
	endif

	sts = pmtracepoint('imouttahere')
	if (sts .lt. 0) then
	    call pmtraceerrstr(sts, emesg)
	    print *,prog,': pmtracepoint error: ',emesg
	    stop 1
	endif

	value = 340.5
	sts = pmtraceobs('end point', value)
	if (sts .lt. 0) then
	    call pmtraceerrstr(sts, emesg)
	    print *,prog,': pmtraceobs error: ',emesg
	    stop 1
	endif

	value = 340.6
	sts = pmtracecounter('new end point', value)
	if (sts .lt. 0) then
	    call pmtraceerrstr(sts, emesg)
	    print *,prog,': pmtracecounter error: ',emesg
	    stop 1
	endif

	end
