/*
 * Copyright 1997, Silicon Graphics, Inc.
 * ALL RIGHTS RESERVED
 * 
 * UNPUBLISHED -- Rights reserved under the copyright laws of the United
 * States.   Use of a copyright notice is precautionary only and does not
 * imply publication or disclosure.
 * 
 * U.S. GOVERNMENT RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in FAR 52.227.19(c)(2) or subparagraph (c)(1)(ii) of the Rights
 * in Technical Data and Computer Software clause at DFARS 252.227-7013 and/or
 * in similar or successor clauses in the FAR, or the DOD or NASA FAR
 * Supplement.  Contractor/manufacturer is Silicon Graphics, Inc.,
 * 2011 N. Shoreline Blvd. Mountain View, CA 94039-7311.
 * 
 * THE CONTENT OF THIS WORK CONTAINS CONFIDENTIAL AND PROPRIETARY
 * INFORMATION OF SILICON GRAPHICS, INC. ANY DUPLICATION, MODIFICATION,
 * DISTRIBUTION, OR DISCLOSURE IN ANY FORM, IN WHOLE, OR IN PART, IS STRICTLY
 * PROHIBITED WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SILICON
 * GRAPHICS, INC.
 */

/*
 * the txmon shm segment
 *
 * control comes at the beginning, with index[] expanded to match the
 * number of transaction types (control->n_tx)
 *
 * then follows one stat_t per transaction type, subject to the
 * constraint that each stat_t is hardware cache aligned to avoid
 * anti-social bus traffic
 *
 * $Id: txmon.h,v 2.3 1997/05/19 20:49:11 kenmcd Exp $
 */

typedef struct {
    int		level;		/* controls stats collection levels */
    int		n_tx;		/* # of tx types */
    int		index[1];	/* will be expanded when allocated */
} control_t;

static control_t	*control;

#define MAXNAMESIZE 20

typedef struct {

    /* managed by txmon PMDA ... do not fiddle with these! */
    char		type[MAXNAMESIZE];	/* tx type name */
    unsigned int	reset_count;	/* tx count @ last reset */

    /* initialized and then read by txmon PMDA, updated by txrecord */
    unsigned int	count;		/* tx count since epoch */
    float		max_time;	/* maximum elapsed time */
    double		sum_time;	/* aggregate elapsed time */
} stat_t;

/* arbitrary shm key */
#define KEY (key_t)0xdeadbeef
